/*
 Copyright 2015 Nicolas Melot

 This file is part of Pelib-SCC.

 Pelib-SCC is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 Pelib-SCC is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Pelib-SCC. If not, see <http://www.gnu.org/licenses/>.

*/


#include <stdlib.h>

#ifndef PELIB_SCC_H
#define PELIB_SCC_H

extern const size_t mpb_size;
extern const char* shared_dir;

typedef struct mpb_stack mpb_stack_t;

int
pelib_scc_core_id();

int
pelib_scc_core_count();

int
pelib_scc_init(int *argc, char ***argv);

int
pelib_scc_finalize();

void*
pelib_scc_malloc_mpb(size_t size);

int
pelib_scc_free(void* ptr);

/*
mpb_stack_t*
pelib_scc_stack_malloc(size_t size);

void*
pelib_scc_stack_grow(mpb_stack_t* stack, size_t size, int id);

int
pelib_scc_stack_free(mpb_stack_t* size_t);
*/

void*
pelib_scc_global_ptr(void* ptr, int id);

size_t
pelib_scc_mpb_size();

void
pelib_scc_force_wcb();

void
pelib_scc_global_barrier();

void
pelib_scc_cache_invalidate();

size_t
pelib_scc_local_offset(void* ptr, int id);

#endif
