/*
 Copyright 2015 Nicolas Melot

 This file is part of Pelib-SCC.

 Pelib-SCC is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 Pelib-SCC is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Pelib-SCC. If not, see <http://www.gnu.org/licenses/>.

*/


/*
 * sync.h
 *
 *  Created on: 17 Apr 2012
 *  Copyright 2012 Nicolas Melot
 *
 * This file is part of pelib-scc.
 * 
 *     pelib-scc is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 * 
 *     pelib-scc is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 * 
 *     You should have received a copy of the GNU General Public License
 *     along with pelib-scc. If not, see <http://www.gnu.org/licenses/>.
 * 
 */

#ifndef SYNC_H_
#define SYNC_H_

enum flag_status
{
  BONJOUR, PELIB_SCC_FLAG_UNSET, PELIB_SCC_FLAG_SET, HELLOWORLD
};
typedef enum flag_status pelib_scc_flag_status;
typedef volatile pelib_scc_flag_status pelib_scc_flag_content;
typedef pelib_scc_flag_content *pelib_scc_flag;

int
pelib_scc_flag_alloc(pelib_scc_flag* flag);

int
pelib_scc_flag_free(pelib_scc_flag* flag);

int
pelib_scc_flag_alloc_local(pelib_scc_flag* flag);

int
pelib_scc_flag_free_local(pelib_scc_flag* flag);

int
pelib_scc_flag_write(pelib_scc_flag* flag, pelib_scc_flag_status value, int destination);

int
pelib_scc_flag_read(pelib_scc_flag flag, pelib_scc_flag_status *value, int destination);

int
pelib_scc_wait_until(pelib_scc_flag flag, pelib_scc_flag_status status);

#if !defined _OPENMP || 1
pelib_scc_flag __pelib_scc_critical_flag;
void
pelib_scc_critical_begin();
void
pelib_scc_critical_end();
#define PELIB_SCC_CRITICAL_BEGIN pelib_scc_critical_begin();
#define PELIB_SCC_CRITICAL_END pelib_scc_critical_end();
#else
#define PELIB_SCC_CRITICAL_BEGIN #pragma omp critical {
#define PELIB_SCC_CRITICAL_END }
#endif

#define PELIB_SCC_SUCCESS PELIB_SUCCESS
#define PELIB_SCC_FAILURE PELIB_FAILURE

#endif /* SYNC_H_ */
